package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public it.csinet.xnObjects.b4aGrid _cgrid = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 23;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(4194304);
 BA.debugLineNum = 24;BA.debugLine="Configura_Pantalla";
Debug.ShouldStop(8388608);
_configura_pantalla();
 BA.debugLineNum = 25;BA.debugLine="Carga_Datos";
Debug.ShouldStop(16777216);
_carga_datos();
 BA.debugLineNum = 26;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 32;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 34;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 28;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 30;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _carga_datos() throws Exception{
		Debug.PushSubsStack("Carga_Datos (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String _campo1 = "";
String _campo2 = "";
String _campo3 = "";
String _campo4 = "";
int _i = 0;
 BA.debugLineNum = 83;BA.debugLine="Sub Carga_Datos";
Debug.ShouldStop(262144);
 BA.debugLineNum = 84;BA.debugLine="Dim Campo1,Campo2,Campo3,Campo4 As String";
Debug.ShouldStop(524288);
_campo1 = "";Debug.locals.put("Campo1", _campo1);
_campo2 = "";Debug.locals.put("Campo2", _campo2);
_campo3 = "";Debug.locals.put("Campo3", _campo3);
_campo4 = "";Debug.locals.put("Campo4", _campo4);
 BA.debugLineNum = 85;BA.debugLine="campo2=\"01/01/2013\"";
Debug.ShouldStop(1048576);
_campo2 = "01/01/2013";Debug.locals.put("Campo2", _campo2);
 BA.debugLineNum = 86;BA.debugLine="Campo3=\"1.250,30\"";
Debug.ShouldStop(2097152);
_campo3 = "1.250,30";Debug.locals.put("Campo3", _campo3);
 BA.debugLineNum = 87;BA.debugLine="Campo4=\"300.00\"";
Debug.ShouldStop(4194304);
_campo4 = "300.00";Debug.locals.put("Campo4", _campo4);
 BA.debugLineNum = 88;BA.debugLine="For i=1 To 150";
Debug.ShouldStop(8388608);
{
final double step52 = 1;
final double limit52 = (int)(150);
for (_i = (int)(1); (step52 > 0 && _i <= limit52) || (step52 < 0 && _i >= limit52); _i += step52) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 89;BA.debugLine="Campo1=\"F-00000\" & i";
Debug.ShouldStop(16777216);
_campo1 = "F-00000"+BA.NumberToString(_i);Debug.locals.put("Campo1", _campo1);
 BA.debugLineNum = 90;BA.debugLine="cgrid.RowAppend  ( Array As String (Campo1,Campo2,Campo3,Campo4,\"\" ) )";
Debug.ShouldStop(33554432);
mostCurrent._cgrid.RowAppend(new String[]{_campo1,_campo2,_campo3,_campo4,""});
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 92;BA.debugLine="cgrid.PropSetHeight(2,60)";
Debug.ShouldStop(134217728);
mostCurrent._cgrid.PropSetHeight((int)(2),(int)(60));
 BA.debugLineNum = 93;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _configura_pantalla() throws Exception{
		Debug.PushSubsStack("Configura_Pantalla (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
it.csinet.xnObjects.xnGridCol[] _cc = null;
 BA.debugLineNum = 37;BA.debugLine="Sub Configura_Pantalla";
Debug.ShouldStop(16);
 BA.debugLineNum = 38;BA.debugLine="If cgrid.IsInitialized = False Then";
Debug.ShouldStop(32);
if (mostCurrent._cgrid.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 39;BA.debugLine="cgrid.Initialize(\"Cgrid\")";
Debug.ShouldStop(64);
mostCurrent._cgrid.Initialize(mostCurrent.activityBA,"Cgrid");
 BA.debugLineNum = 41;BA.debugLine="cgrid.RowHeight = 30dip";
Debug.ShouldStop(256);
mostCurrent._cgrid.setRowHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 42;BA.debugLine="cgrid.HeaderColor = Colors.Gray";
Debug.ShouldStop(512);
mostCurrent._cgrid.setHeaderColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 43;BA.debugLine="cgrid.RowEvenColor = Colors.White";
Debug.ShouldStop(1024);
mostCurrent._cgrid.setRowEvenColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 BA.debugLineNum = 44;BA.debugLine="cgrid.RowOddColor = Colors.RGB(192,255,192)";
Debug.ShouldStop(2048);
mostCurrent._cgrid.setRowOddColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(255),(int)(192)));
 BA.debugLineNum = 45;BA.debugLine="cgrid.GridColor=Colors.Black";
Debug.ShouldStop(4096);
mostCurrent._cgrid.setGridColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 46;BA.debugLine="cgrid.HeaderHeight = 30dip";
Debug.ShouldStop(8192);
mostCurrent._cgrid.setHeaderHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30)));
 BA.debugLineNum = 48;BA.debugLine="cgrid.HeaderTextSize = 13";
Debug.ShouldStop(32768);
mostCurrent._cgrid.setHeaderTextSize((float)(13));
 BA.debugLineNum = 49;BA.debugLine="cgrid.RowTextSize = 12";
Debug.ShouldStop(65536);
mostCurrent._cgrid.setRowTextSize((float)(12));
 BA.debugLineNum = 50;BA.debugLine="cgrid.HeaderTextColor = Colors.Black";
Debug.ShouldStop(131072);
mostCurrent._cgrid.setHeaderTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 51;BA.debugLine="cgrid.RowTextColor = Colors.Black";
Debug.ShouldStop(262144);
mostCurrent._cgrid.setRowTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 53;BA.debugLine="cgrid.SelectedOddColor = Colors.RGB(192,192,255)";
Debug.ShouldStop(1048576);
mostCurrent._cgrid.setSelectedOddColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(192),(int)(255)));
 BA.debugLineNum = 54;BA.debugLine="cgrid.SelectedEvenColor = Colors.RGB(192,192,255)";
Debug.ShouldStop(2097152);
mostCurrent._cgrid.setSelectedEvenColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(192),(int)(255)));
 BA.debugLineNum = 57;BA.debugLine="Dim cc(9) As xnGridCol";
Debug.ShouldStop(16777216);
_cc = new it.csinet.xnObjects.xnGridCol[(int)(9)];
{
int d0 = _cc.length;
for (int i0 = 0;i0 < d0;i0++) {
_cc[i0] = new it.csinet.xnObjects.xnGridCol();
}
}
;Debug.locals.put("cc", _cc);
 BA.debugLineNum = 59;BA.debugLine="cc(0).Initialize2 (\"Nº Factura\" , \"Campo1\" , 80dip , Gravity.CENTER_HORIZONTAL +Gravity.CENTER_VERTICAL)";
Debug.ShouldStop(67108864);
_cc[(int)(0)].Initialize2("Nº Factura","Campo1",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 60;BA.debugLine="cc(0).HeaderGravity = Gravity.CENTER_VERTICAL  + Gravity.CENTER_HORIZONTAL";
Debug.ShouldStop(134217728);
_cc[(int)(0)].setHeaderGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL));
 BA.debugLineNum = 61;BA.debugLine="cgrid.ColAppend  ( cc(0) )";
Debug.ShouldStop(268435456);
mostCurrent._cgrid.ColAppend(_cc[(int)(0)]);
 BA.debugLineNum = 64;BA.debugLine="cc(1).Initialize2 (\"Fecha\", \"Campo2\" , 80dip  , Gravity.CENTER_HORIZONTAL+Gravity.CENTER_VERTICAL  )";
Debug.ShouldStop(-2147483648);
_cc[(int)(1)].Initialize2("Fecha","Campo2",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 65;BA.debugLine="cc(1).HeaderGravity = Gravity.CENTER_VERTICAL  + Gravity.CENTER_HORIZONTAL";
Debug.ShouldStop(1);
_cc[(int)(1)].setHeaderGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL));
 BA.debugLineNum = 66;BA.debugLine="cgrid.ColAppend ( cc(1) )";
Debug.ShouldStop(2);
mostCurrent._cgrid.ColAppend(_cc[(int)(1)]);
 BA.debugLineNum = 68;BA.debugLine="cc(2).Initialize2 (\"Imp.Ftra.\", \"Campo3\" , 80dip , Gravity.RIGHT+Gravity.CENTER_VERTICAL  )";
Debug.ShouldStop(8);
_cc[(int)(2)].Initialize2("Imp.Ftra.","Campo3",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.RIGHT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 69;BA.debugLine="cc(2).HeaderGravity = Gravity.CENTER_VERTICAL  + Gravity.CENTER_HORIZONTAL";
Debug.ShouldStop(16);
_cc[(int)(2)].setHeaderGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL));
 BA.debugLineNum = 70;BA.debugLine="cgrid.ColAppend ( cc(2) )";
Debug.ShouldStop(32);
mostCurrent._cgrid.ColAppend(_cc[(int)(2)]);
 BA.debugLineNum = 72;BA.debugLine="cc(3).Initialize2 ( \"Deuda\" , \"Campo4\" ,  80dip ,  Gravity.RIGHT+Gravity.CENTER_VERTICAL   )";
Debug.ShouldStop(128);
_cc[(int)(3)].Initialize2("Deuda","Campo4",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.RIGHT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 73;BA.debugLine="cc(3).HeaderGravity = Gravity.CENTER_VERTICAL  + Gravity.CENTER_HORIZONTAL";
Debug.ShouldStop(256);
_cc[(int)(3)].setHeaderGravity((int)(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL));
 BA.debugLineNum = 74;BA.debugLine="cgrid.ColAppend ( cc(3) )";
Debug.ShouldStop(512);
mostCurrent._cgrid.ColAppend(_cc[(int)(3)]);
 BA.debugLineNum = 76;BA.debugLine="cgrid.ColAppend ( cc(8) )";
Debug.ShouldStop(2048);
mostCurrent._cgrid.ColAppend(_cc[(int)(8)]);
 BA.debugLineNum = 77;BA.debugLine="Activity.AddView(cgrid,4dip,0dip,Activity.Width-6dip,Activity.Height-6dip)";
Debug.ShouldStop(4096);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._cgrid.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(4)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),(int)(mostCurrent._activity.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(6))),(int)(mostCurrent._activity.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(6))));
 BA.debugLineNum = 78;BA.debugLine="cgrid.GridWidth = 1dip";
Debug.ShouldStop(8192);
mostCurrent._cgrid.setGridWidth(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1)));
 BA.debugLineNum = 79;BA.debugLine="cgrid.GridCreate2 (True)";
Debug.ShouldStop(16384);
mostCurrent._cgrid.GridCreate2(anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 81;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 23123, new int[] {3}, "902c88c4-55c6-4a6f-a368-682f76e7da31");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim cgrid As xnGrid";
mostCurrent._cgrid = new it.csinet.xnObjects.b4aGrid();
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"cgrid",_cgrid};
}
}
